package edu.dissertation.json;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.LinkedList;

import javax.json.Json;
import javax.json.stream.JsonParser;
import javax.json.stream.JsonParser.Event;

public class GenericJSONParser {
	
	
	
	public static int GetParentElement(ArrayList<jsonSlice> JsonSliceList, int Nivel ) {

	  		for(int i= JsonSliceList.size() - 1; i > 0; i--){
		
				switch (JsonSliceList.get(i).getTipo()) {
				case START_ARRAY:
					return JsonSliceList.get(i-1).getObjectId();
				case START_OBJECT:
					return JsonSliceList.get(i-1).getObjectId();
				}
		   		 
			}
			return 0;
		}	
	
	public static String GetOcurrenceOf(ArrayList<jsonSlice> JsonSliceList, Event e, int Posicao) {
		
/*		JsonSliceList.indexOf(e);
		   for(jsonSlice d : JsonSliceList){
		        if(d.getTipo()) != null && d.getName().contains(search))
		           //something here
		    }*/
		   
			int count = 0;
			int count1 = 0;
			
			for (int i = 0; i < JsonSliceList.size(); i++)
			{   count1 = i; 
				if(e.equals(JsonSliceList.get(i).getTipo()))
		            ++count;
		            if(count==Posicao) {break;}
	        }
					
		    return JsonSliceList.get(count1).getValor();
			
			// String searched = "bat";
/*			long n = IntStream.range(0, JsonSliceList.size())
			            .filter(i -> JsonSliceList.equals(JsonSliceList.get(i)))
			            .count();
		    return JsonSliceList.get(2).getValor(); */
			
//		   Optional<jsonSlice> FistOcurrence = 
//				   JsonSliceList
//				    .stream()
//				    .filter(p-> p.getTipo().equals(e));
//
//		
//		return FistOcurrence;
	}

	
	public static void main(String[] args) throws IOException {
		
		
		String ClassName = "Person";
		String MainKey = null;
		int ObjectId = 0;
		int Nivel = 0;
		Event SliceEvent;
		LinkedList<Integer> IsinObject = new LinkedList<Integer>();
		LinkedList<Integer> IsinArray = new LinkedList<Integer>();
		IsinObject.add(0);
		IsinArray.add(0);
		

		ArrayList<jsonSlice> JsonSliceList = new ArrayList<jsonSlice>();
		
		//URL url = new URL("https://data.cityofchicago.org/api/views/x8fc-8rcq/rows.json?accessType=DOWNLOAD");
		//URL url = new URL("http://data.consumerfinance.gov/api/views.json");
		//		 try (InputStream is = url.openStream();
		try (InputStream is = new FileInputStream(new File("/home/pulgatti/Dropbox/Mestrado/Dissertação Pulgatti/teste.json"));
		 JsonParser parser = Json.createParser(is)) {
		 
		 while (parser.hasNext()) {

		//	 try {
			 SliceEvent = parser.next();
		//	 } catch (javax.json.stream.JsonParsingException err) {
		//		  System.out.println("erro: " + err);
		//	 }
				
				
			 jsonSlice JsonSlice = new jsonSlice(); 
			
				JsonSlice.setTipo(SliceEvent);
				JsonSlice.setNivel(Nivel);
				JsonSlice.setObjPai(Math.max(IsinObject.getLast(), IsinArray.getLast()));
				JsonSlice.setObjectId(++ObjectId);
		   		 
				switch (SliceEvent) {
				case START_OBJECT:							
					JsonSlice.setValor(null);
					JsonSlice.setNivel(++Nivel);
					IsinObject.add(ObjectId);
					break;
					
				case START_ARRAY:
					JsonSlice.setValor(null);
					JsonSlice.setObjPai( ObjectId - 1 );	// só pode ser filho de objeto normal ??? verificar na norma ISO
					JsonSlice.setNivel(++Nivel);
					IsinArray.add(ObjectId);
					break;
					
				case END_OBJECT:
					JsonSlice.setValor(null);
					Nivel--;
					IsinObject.removeLast();
					break;
					
				case END_ARRAY:
					JsonSlice.setValor(null);
					Nivel--;
					IsinArray.removeLast();
					break;
					
				case KEY_NAME:
				case VALUE_STRING:
				case VALUE_NUMBER:
					JsonSlice.setValor(parser.getString());
					break;

				case VALUE_TRUE:
					JsonSlice.setValor("TRUE");
					break;
					
				case VALUE_FALSE:
					JsonSlice.setValor("FALSE");
					break;
					
				case VALUE_NULL:
					JsonSlice.setValor("NULL");
					break;

				}
				
				JsonSliceList.add(JsonSlice);
				
				System.out.println (String.format("%"+ JsonSlice.getNivel() * 2 +"s", " ") + "ObjectId	: " + JsonSlice.getObjectId());
				System.out.println (String.format("%"+ JsonSlice.getNivel() * 2 +"s", " ") + "SliceValue	: " + JsonSlice.getValor());
				System.out.println (String.format("%"+ JsonSlice.getNivel() * 2 +"s", " ") + "SliceLevel	: " + JsonSlice.getNivel());
				System.out.println (String.format("%"+ JsonSlice.getNivel() * 2 +"s", " ") + "SliceEvent	: " + JsonSlice.getTipo() );
				System.out.println (String.format("%"+ JsonSlice.getNivel() * 2 +"s", " ") + "ObjPai		: " + JsonSlice.getObjPai());
				System.out.println ("" );
				
			}
		}
	
		MainKey =  ClassName + ":" + GetOcurrenceOf(JsonSliceList, Event.VALUE_STRING, 1 );
		System.out.println ("MainKey = " + MainKey );
		System.out.println(JsonReWrite.kvpo(JsonSliceList));
		System.out.println();
		
		System.out.println ("kvpf ");
		System.out.println(JsonReWrite.kvpf(MainKey, JsonSliceList));
		System.out.println();
		
		System.out.println ("khpf ");
		System.out.println(JsonReWrite.khpf(MainKey, JsonSliceList));
		System.out.println();
		
		System.out.println ("kvpfMM ");
		System.out.println(JsonReWrite.kvpfMM(MainKey, JsonSliceList));
		System.out.println();
		
		System.out.println ("kvpav ");
		System.out.println(JsonReWrite.kvpav(MainKey, JsonSliceList));
		System.out.println();
		
		
		
		
		// Key-value per object		Person:John {"firstName":"John", "lastName": "Smith", "age": 25, "phoneNumber": [ { "type": "home", "number": "212 555-1234" }, { "type": "fax","number": "646 555-4567" }]}
	
	  }
	}



