package edu.dissertation.json;

import java.util.ArrayList;

public class JsonReWrite {
	
	public static String kvpo(ArrayList<jsonSlice> JsonSliceList) 
	{
		String Linha = null ;
		
		for (int i = 0; i < JsonSliceList.size(); i++)
		{   
			switch (JsonSliceList.get(i).getTipo()) {
			case START_OBJECT:
				Linha = Linha + "{";
				break;
				
			case START_ARRAY:
				Linha = Linha + "[";
				break;
				
			case END_OBJECT:
				Linha = Linha + "}";
				break;
				
			case END_ARRAY:
				Linha = Linha + "]";
				break;
				
			case KEY_NAME:
				Linha = Linha + "\"" + JsonSliceList.get(i).getValor() + "\":";
				break;
			case VALUE_STRING:
			case VALUE_NUMBER:
			case VALUE_TRUE:
			case VALUE_FALSE:
			case VALUE_NULL:
				Linha = Linha + "\"" + JsonSliceList.get(i).getValor() + "\" , ";
				break;
			}
        }
		return Linha;
	}

//	kvpf()	Key		= MainKey + / + Tokens.KEY_NAME.exists
//			Value	= Tokens.KEY_NAME.Value (If Value = Array then Tokens.concatenate.all.array)

	public static String kvpf(String mainKey, ArrayList<jsonSlice> JsonSliceList) 
	{
		String Linha = null ;
		boolean IsInArray = false;
		
		for (int i = 0; i < JsonSliceList.size(); i++)
		{   
			switch (JsonSliceList.get(i).getTipo()) {
			case START_OBJECT:
				if (IsInArray==false) {Linha = Linha + mainKey + "/";}
				else {Linha = Linha + "{";}
				break;
				
			case START_ARRAY:
				IsInArray = true;
				Linha = Linha + "[";
				break;
				
			case END_OBJECT:
				if (IsInArray==true) {Linha = Linha + "}";}
				break;
				
			case END_ARRAY:
				IsInArray = false;
				Linha = Linha + "]";
				break;
				
			case KEY_NAME:
				if (IsInArray==true) { Linha = Linha + "\"" + JsonSliceList.get(i).getValor() + "\":";}
				else {Linha = Linha + mainKey + "/" + JsonSliceList.get(i).getValor() + " ";}
				break;
			case VALUE_STRING:
			case VALUE_NUMBER:
			case VALUE_TRUE:
			case VALUE_FALSE:
			case VALUE_NULL:
				if (IsInArray==true) {Linha = Linha + "\"" + JsonSliceList.get(i).getValor() + "\" , ";}
				else {Linha = Linha + JsonSliceList.get(i).getValor() + "\r\n " ;}
				break;
			}
        }
		return Linha;
	}

	public static String khpf(String mainKey, ArrayList<jsonSlice> jsonSliceList) {
		return "khpf";
	}

	public static String kvpfMM(String mainKey, ArrayList<jsonSlice> jsonSliceList) {
		return "kvpfMM";
	}

	public static String kvpav(String mainKey, ArrayList<jsonSlice> jsonSliceList) {
		return "kvpav";
	}

	

	
	
	
}
